## ignition-math6 6.15.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

#============================================================================
# Initialize the project
#============================================================================
project(ignition-math6 VERSION 6.15.1)

#============================================================================
# Find ignition-cmake
#============================================================================
# If you get an error at this line, you need to install ignition-cmake
find_package(ignition-cmake2 2.13.0 REQUIRED)

#============================================================================
# Configure the project
#============================================================================
set (c++standard 17)
set (CMAKE_CXX_STANDARD 17)
ign_configure_project(
  REPLACE_IGNITION_INCLUDE_PATH gz/math
  VERSION_SUFFIX
)

#============================================================================
# Set project-specific options
#============================================================================

option(SKIP_SWIG
      "Skip generating ruby bindings via Swig"
      OFF)

set(skip_pybind11_default_value OFF)
if (MSVC)
  set(skip_pybind11_default_value ON)
endif()

option(SKIP_PYBIND11
      "Skip generating Python bindings via pybind11"
      ${skip_pybind11_default_value})

include(CMakeDependentOption)
cmake_dependent_option(USE_SYSTEM_PATHS_FOR_RUBY_INSTALLATION
      "Install ruby modules in standard system paths in the system"
      OFF "NOT SKIP_SWIG" OFF)

cmake_dependent_option(USE_SYSTEM_PATHS_FOR_PYTHON_INSTALLATION
      "Install python modules in standard system paths in the system"
      OFF "NOT SKIP_PYBIND11" OFF)

cmake_dependent_option(USE_DIST_PACKAGES_FOR_PYTHON
      "Use dist-packages instead of site-package to install python modules"
      OFF "NOT SKIP_PYBIND11" OFF)

#============================================================================
# Search for project-specific dependencies
#============================================================================

#--------------------------------------
# Find eigen3
ign_find_package(
  EIGEN3
  REQUIRED_BY eigen3
  PRETTY eigen3
  PURPOSE "Provide conversions to eigen3 types")

########################################
# Include swig
if (SKIP_SWIG)
  message(STATUS "SKIP_SWIG set - disabling SWIG Ruby support")
else()
  find_package(SWIG QUIET)
  if (NOT SWIG_FOUND)
    IGN_BUILD_WARNING("Swig is missing: Language interfaces are disabled.")
    message (STATUS "Searching for swig - not found.")
  else()
    message (STATUS "Searching for swig - found version ${SWIG_VERSION}.")
  endif()

  # Include other languages if swig was found
  if (SWIG_FOUND)
    ########################################
    # Include ruby
    find_package(Ruby 1.9 QUIET)
    if (NOT RUBY_FOUND)
      IGN_BUILD_WARNING("Ruby is missing: Install ruby-dev to enable ruby interface to ignition math.")
      message (STATUS "Searching for Ruby - not found.")
    else()
      message (STATUS "Searching for Ruby - found version ${RUBY_VERSION}.")
    endif()
  endif()
endif()

########################################
# Python bindings
if (SKIP_PYBIND11)
  message(STATUS "SKIP_PYBIND11 set - disabling python bindings")
else()
  #include(IgnPython) TODO: allow to specify for what it should search and then
  # the code below can be removed; e.g. pybind needs Interpreter and Development components
  # see https://pybind11.readthedocs.io/en/stable/cmake/index.html#new-findpython-mode
  if(${CMAKE_VERSION} VERSION_LESS "3.12.0")
    set(IGN_PYTHON_VERSION "3")
    find_package(PythonInterp ${IGN_PYTHON_VERSION} QUIET)
    if(PYTHONINTERP_FOUND)
      set(Python3_FOUND ${PYTHONINTERP_FOUND})
      set(Python3_Interpreter_FOUND ${PYTHONINTERP_FOUND})
      set(Python3_EXECUTABLE ${PYTHON_EXECUTABLE})
      find_package(PythonLibs QUIET)
      # we found the interpreter but did we also find the libs? both are required
      set(Python3_FOUND ${PYTHONLIBS_FOUND})
      set(Python3_VERSION ${PYTHONLIBS_VERSION_STRING})
    endif()
  else()
    find_package(Python3 QUIET COMPONENTS Interpreter Development)
  endif()

  if (NOT Python3_FOUND)
    IGN_BUILD_WARNING("Python3 is missing: Python interfaces are disabled.")
    message (STATUS "Searching for Python3 - not found.")
  else()
    message (STATUS "Searching for Python3 - found version ${Python3_VERSION}.")

    set(PYBIND11_PYTHON_VERSION 3)
    find_package(pybind11 2.2 QUIET)

    if (${pybind11_FOUND})
      message (STATUS "Searching for pybind11 - found version ${pybind11_VERSION}.")
    else()
      IGN_BUILD_WARNING("pybind11 is missing: Python interfaces are disabled.")
      message (STATUS "Searching for pybind11 - not found.")
    endif()
  endif()
endif()

# Location of "fake install folder" used in tests
# Defined here at root scope so it is available for tests in src and test folders
set(FAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/fake/install")

#============================================================================
# Configure the build
#============================================================================
ign_configure_build(QUIT_IF_BUILD_ERRORS
  COMPONENTS eigen3)


#============================================================================
# Create package information
#============================================================================
ign_create_packages()

#============================================================================
# Configure documentation
#============================================================================
configure_file(${CMAKE_SOURCE_DIR}/api.md.in ${CMAKE_BINARY_DIR}/api.md)
configure_file(${CMAKE_SOURCE_DIR}/tutorials.md.in ${CMAKE_BINARY_DIR}/tutorials.md)

ign_create_docs(
  API_MAINPAGE_MD "${CMAKE_BINARY_DIR}/api.md"
  TUTORIALS_MAINPAGE_MD "${CMAKE_BINARY_DIR}/tutorials.md")

=== src/python_pybind11/CMakeLists.txt ===
if(${CMAKE_VERSION} VERSION_LESS "3.12.0")
  # TODO: remove once the minimum CMake version is increased
  if(WIN32 AND CMAKE_BUILD_TYPE STREQUAL "Debug")
    # pybind11 logic for setting up a debug build when both a debug and release
    # python interpreter are present in the system seems to be pretty much broken.
    # This works around the issue.
    set(PYTHON_LIBRARIES "${PYTHON_DEBUG_LIBRARIES}")
  endif()
endif()

message(STATUS "Building pybind11 interfaces")
# Split from main extension and converted to pybind11
pybind11_add_module(math SHARED
  src/_ignition_math_pybind11.cc
  src/Angle.cc
  src/AxisAlignedBox.cc
  src/Capsule.cc
  src/Color.cc
  src/DiffDriveOdometry.cc
  src/Ellipsoid.cc
  src/Filter.cc
  src/Frustum.cc
  src/GaussMarkovProcess.cc
  src/Helpers.cc
  src/Interval.cc
  src/Kmeans.cc
  src/Line2.cc
  src/Line3.cc
  src/MassMatrix3.cc
  src/Material.cc
  src/Matrix3.cc
  src/Matrix4.cc
  src/Matrix6.cc
  src/MovingWindowFilter.cc
  src/PID.cc
  src/Polynomial3.cc
  src/Pose3.cc
  src/Quaternion.cc
  src/Rand.cc
  src/Region3.cc
  src/RollingMean.cc
  src/RotationSpline.cc
  src/SemanticVersion.cc
  src/SignalStats.cc
  src/SphericalCoordinates.cc
  src/Spline.cc
  src/StopWatch.cc
  src/Temperature.cc
  src/Triangle.cc
  src/Triangle3.cc
  src/Vector2.cc
  src/Vector3.cc
  src/Vector4.cc
  src/Vector3Stats.cc
)

target_link_libraries(math PRIVATE
  ${PROJECT_LIBRARY_TARGET_NAME}
)

if(USE_SYSTEM_PATHS_FOR_PYTHON_INSTALLATION)
  # Get install variable from Python3 module
  if(${CMAKE_VERSION} VERSION_LESS "3.12.0")
    # Python3_SITEARCH is available via FindPython3 from 3.12 on, workaround if needed
    execute_process(
      COMMAND "${Python3_EXECUTABLE}" -c "if True:
  from distutils import sysconfig as sc
  print(sc.get_python_lib(plat_specific=True))"
      OUTPUT_VARIABLE Python3_SITEARCH
      OUTPUT_STRIP_TRAILING_WHITESPACE)
  endif()

  if(USE_DIST_PACKAGES_FOR_PYTHON)
    string(REPLACE "site-packages" "dist-packages" IGN_PYTHON_INSTALL_PATH ${Python3_SITEARCH})
  else()
    # custom cmake command is returning dist-packages
    string(REPLACE "dist-packages" "site-packages" IGN_PYTHON_INSTALL_PATH ${Python3_SITEARCH})
  endif()
else()
  # If not a system installation, respect local paths
  set(IGN_PYTHON_INSTALL_PATH ${IGN_LIB_INSTALL_DIR}/python)
endif()

set(IGN_PYTHON_INSTALL_PATH "${IGN_PYTHON_INSTALL_PATH}/ignition")

# Set the build location and install location for a CPython extension
function(configure_build_install_location _library_name)
  # Install into test folder in build space for unit tests to import
  set_target_properties(${_library_name} PROPERTIES
    # Use generator expression to avoid prepending a build type specific directory on Windows
    LIBRARY_OUTPUT_DIRECTORY $<1:${CMAKE_CURRENT_BINARY_DIR}/test>
    RUNTIME_OUTPUT_DIRECTORY $<1:${CMAKE_CURRENT_BINARY_DIR}/test>)

  # Install library for actual use
  install(TARGETS ${_library_name}
    DESTINATION "${IGN_PYTHON_INSTALL_PATH}/"
  )
endfunction()

configure_build_install_location(math)

if (BUILD_TESTING)
  # Add the Python tests
  set(python_tests
    Angle_TEST
    AxisAlignedBox_TEST
    Box_TEST
    Capsule_TEST
    Color_TEST
    Cylinder_TEST
    DiffDriveOdometry_TEST
    Ellipsoid_TEST
    Filter_TEST
    Frustum_TEST
    GaussMarkovProcess_TEST
    Helpers_TEST
    Inertial_TEST
    Interval_TEST
    Kmeans_TEST
    Line2_TEST
    Line3_TEST
    MassMatrix3_TEST
    Material_TEST
    Matrix3_TEST
    Matrix4_TEST
    Matrix6_TEST
    MovingWindowFilter_TEST
    OrientedBox_TEST
    PID_TEST
    Plane_TEST
    Polynomial3_TEST
    Pose3_TEST
    Quaternion_TEST
    Rand_TEST
    Region3_TEST
    RollingMean_TEST
    RotationSpline_TEST
    SemanticVersion_TEST
    SignalStats_TEST
    Sphere_TEST
    SphericalCoordinates_TEST
    Spline_TEST
    StopWatch_TEST
    Temperature_TEST
    Triangle3_TEST
    Triangle_TEST
    Vector2_TEST
    Vector3_TEST
    Vector3Stats_TEST
    Vector4_TEST
  )

  execute_process(COMMAND "${Python3_EXECUTABLE}" -m pytest --version
    OUTPUT_VARIABLE PYTEST_output
    ERROR_VARIABLE  PYTEST_error
    RESULT_VARIABLE PYTEST_result)
  if(${PYTEST_result} EQUAL 0)
    set(pytest_FOUND TRUE)
  else()
    message("")
    message(WARNING "Pytest package not available: ${PYTEST_error}")
  endif()

  foreach (test ${python_tests})
    if (pytest_FOUND)
      add_test(NAME ${test}.py COMMAND
        "${Python3_EXECUTABLE}" -m pytest "${CMAKE_SOURCE_DIR}/src/python_pybind11/test/${test}.py" --junitxml "${CMAKE_BINARY_DIR}/test_results/${test}.xml")
    else()
      add_test(NAME ${test}.py COMMAND
        "${Python3_EXECUTABLE}" "${CMAKE_SOURCE_DIR}/src/python_pybind11/test/${test}.py")
    endif()

    set(_env_vars)
    list(APPEND _env_vars "PYTHONPATH=${FAKE_INSTALL_PREFIX}/lib/python/")
    list(APPEND _env_vars "LD_LIBRARY_PATH=${FAKE_INSTALL_PREFIX}/lib:$ENV{LD_LIBRARY_PATH}")
    set_tests_properties(${test}.py PROPERTIES
      ENVIRONMENT "${_env_vars}")
  endforeach()

endif()

=== src/ruby/CMakeLists.txt ===
#################################################
# Setup swig
if (SWIG_FOUND)
  if (POLICY CMP0078)
    cmake_policy(SET CMP0078 NEW)
  endif()
  if (POLICY CMP0086)
    cmake_policy(SET CMP0086 NEW)
  endif()

  include(${SWIG_USE_FILE})
  set(CMAKE_SWIG_FLAGS "")

  include_directories(${PROJECT_SOURCE_DIR}/include)

  set(swig_files
    Angle
    GaussMarkovProcess
    Rand
    Vector2
    Vector3
    Vector4)
endif()

#################################################
# Create and install Ruby interfaces
# Example usage
# $ export RUBYLIB=/usr/local/lib/ruby
# $ ruby -e "require 'ignition/math'; a = Ignition::Math::Angle.new(20); puts a.Degree()"
if (RUBY_FOUND)
  foreach (swig_file ${swig_files})
    # Assuming that each swig file has a test
    list(APPEND ruby_tests ${swig_file}_TEST)

    # Generate the list if .i files
    list(APPEND swig_i_files ${swig_file}.i)
  endforeach()
  list(APPEND ruby_tests ruby_TEST)

  # Turn on c++
  set_source_files_properties(${swig_i_files} ruby.i PROPERTIES CPLUSPLUS ON)
  set(SWIG_RB_LIB rbmath)
  set(SWIG_RB_LIB_OUTPUT math)

  # Create the ruby library
  set(CMAKE_SWIG_OUTDIR "${CMAKE_BINARY_DIR}/lib/ruby")
  if(CMAKE_VERSION VERSION_GREATER 3.8.0)
    SWIG_ADD_LIBRARY(${SWIG_RB_LIB} LANGUAGE ruby SOURCES ruby.i ${swig_i_files})
  else()
    SWIG_ADD_MODULE(${SWIG_RB_LIB} ruby ruby.i ${swig_i_files})
  endif()

  # Suppress warnings on SWIG-generated files
  target_compile_options(${SWIG_RB_LIB} PRIVATE
    $<$<CXX_COMPILER_ID:GNU>:-Wno-pedantic -Wno-shadow -Wno-maybe-uninitialized -Wno-unused-parameter>
    $<$<CXX_COMPILER_ID:Clang>:-Wno-shadow -Wno-maybe-uninitialized -Wno-unused-parameter>
    $<$<CXX_COMPILER_ID:AppleClang>:-Wno-shadow -Wno-maybe-uninitialized -Wno-unused-parameter>
  )
  target_include_directories(${SWIG_RB_LIB} SYSTEM PUBLIC ${RUBY_INCLUDE_DIRS})

  SWIG_LINK_LIBRARIES(${SWIG_RB_LIB}
    ${RUBY_LIBRARY}
    ignition-math${PROJECT_VERSION_MAJOR}
  )
  target_compile_features(${SWIG_RB_LIB} PUBLIC ${IGN_CXX_${c++standard}_FEATURES})

  set_target_properties(${SWIG_RB_LIB}
    PROPERTIES
      OUTPUT_NAME ${SWIG_RB_LIB_OUTPUT}
  )

  if(USE_SYSTEM_PATHS_FOR_RUBY_INSTALLATION)
    execute_process(
      COMMAND ${RUBY_EXECUTABLE} -r rbconfig -e "print RbConfig::CONFIG['vendordir']"
      OUTPUT_VARIABLE IGN_RUBY_INSTALL_PATH
      OUTPUT_STRIP_TRAILING_WHITESPACE)
  else()
      set(IGN_RUBY_INSTALL_PATH ${IGN_LIB_INSTALL_DIR}/ruby)
  endif()
  set(IGN_RUBY_INSTALL_PATH "${IGN_RUBY_INSTALL_PATH}/ignition")
  install(TARGETS ${SWIG_RB_LIB} DESTINATION ${IGN_RUBY_INSTALL_PATH})

  # Add the ruby tests
  set(_env_vars)
  list(APPEND _env_vars "LD_LIBRARY_PATH=${FAKE_INSTALL_PREFIX}/lib:$ENV{LD_LIBRARY_PATH}")
  foreach (test ${ruby_tests})
    add_test(NAME ${test}.rb COMMAND
      ruby -I${FAKE_INSTALL_PREFIX}/lib/ruby/ignition ${CMAKE_SOURCE_DIR}/src/ruby/${test}.rb
   	  --gtest_output=xml:${CMAKE_BINARY_DIR}/test_results/${test}rb.xml)
    set_tests_properties(${test}.rb PROPERTIES
      ENVIRONMENT "${_env_vars}")
  endforeach()
endif()

=== include/gz/math/CMakeLists.txt ===
# Exclude the detail directory from inclusion. The purpose is to prevent the detail/* header files from being included in math.hh. A side effect is that the detail headers are not installed. The next install line solves this problem.
ign_install_all_headers(EXCLUDE_DIRS detail)
install(DIRECTORY detail DESTINATION ${IGN_INCLUDE_INSTALL_DIR_FULL}/gz/${GZ_DESIGNATION})

=== debian/changelog ===
ignition-math6 (6.15.1-1~jammy) jammy; urgency=medium

  * ignition-math6 6.15.1-1 release

 -- Addisu Z. Taddese <addisu@openrobotics.org>  Fri, 05 Jan 2024 14:39:27 -0600

## ignition-math6 6.15.1-3jammy.20260113.2027

=== debian/changelog ===
ignition-math6 (6.15.1-3jammy.20260113.2027) UNRELEASED; urgency=medium

  * ignition-math6 6.15.1-3 release

 -- MAINTAINER <EMAIL>  Tue, 13 Jan 2026 20:27:29 +0000

=== debian/control ===
Source: ignition-math6
Maintainer: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: extra
Build-Depends: cmake,
               debhelper (>= 12),
               dh-python,
               doxygen,
               libeigen3-dev,
               libignition-cmake2-dev (>= 2.13.0) | libignition-cmake-dev (>= 2.13.0),
               python3,
               python3-dev,
               python3-setuptools,
               python3-pybind11,
               ruby-dev,
               ruby-ronn,
               swig
Vcs-Browser: https://github.com/gazebosim/gz-math
Vcs-Git: https://github.com/gazebosim/gz-math.git
Standards-Version: 4.5.1
Homepage: https://github.com/gazebosim/gz-math
XS-Ruby-Versions: all
X-Python3-Version: >= 3.2

Package: libignition-math6
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Provides: libignition-math6-6 (= ${binary:Version})
Replaces: libignition-math6-6 (<< ${binary:Version})
Breaks: libignition-math6-6 (<< ${binary:Version})
Description: Gazebo Math Library - Shared library
 A small, fast, and high performance math library. This library is a
 self-contained set of classes and functions suitable for robot applications.
 .
 Gazebo is a set of simple libraries that provide useful
 functionality to bootstrap robot applications. The included libraries
 encapsulate all the essentials, such as common math data types, console
 logging, 3D mesh management, and asynchronous message passing.

Package: libignition-math6-dev
Architecture: any
Section: libdevel
Depends: libignition-math6 (= ${binary:Version}),
         libignition-cmake2-dev (>= 2.13.0),
         ${misc:Depends}
Replaces: libignition-math-dev (<< ${binary:Version})
Breaks: libignition-math-dev (<< ${binary:Version})
Provides: libignition-math-dev (= ${binary:Version})
Multi-Arch: same
Description: Gazebo Math Library - Development files
 A small, fast, and high performance math library. This library is a
 self-contained set of classes and functions suitable for robot applications.
 .
 Gazebo is a set of simple libraries that provide useful
 functionality to bootstrap robot applications. The included libraries
 encapsulate all the essentials, such as common math data types, console
 logging, 3D mesh management, and asynchronous message passing.

Package: libignition-math6-eigen3-dev
Architecture: any
Section: libdevel
Depends: libignition-math6-dev (= ${binary:Version}),
         libeigen3-dev,
         ${misc:Depends}
Replaces: libignition-math-dev (<< ${binary:Version}),
          libignition-math6-dev (<< ${binary:Version})
Breaks: libignition-math-dev (<< ${binary:Version}),
        libignition-math6-dev (<< ${binary:Version})
Multi-Arch: same
Description: Gazebo Math Library - Eigen3 Development files
 A small, fast, and high performance math library. This library is a
 self-contained set of classes and functions suitable for robot applications.
 .
 Gazebo is a set of simple libraries that provide useful
 functionality to bootstrap robot applications. The included libraries
 encapsulate all the essentials, such as common math data types, console
 logging, 3D mesh management, and asynchronous message passing.
 .
 The package contains the development files relative to Eigen

Package: python3-ignition-math6
Architecture: any
Depends: libignition-math6 (= ${binary:Version}),
         python3-setuptools,
         python3-pybind11,
         ${misc:Depends},
         ${python3:Depends}
Enhances: libignition-math6
Description: Gazebo Math Library - Python3 bindings
 A small, fast, and high performance math library. This library is a
 self-contained set of classes and functions suitable for robot applications.
 .
 Gazebo is a set of simple libraries that provide useful
 functionality to bootstrap robot applications. The included libraries
 encapsulate all the essentials, such as common math data types, console
 logging, 3D mesh management, and asynchronous message passing.
 .
 The package contains the Python3 bindings.

Package: ruby-ignition-math6
Architecture: any
XB-Ruby-Versions: ${ruby:Versions}
Depends: libignition-math6 (= ${binary:Version}),
         ${misc:Depends},
         ${ruby:Depends},
         ${shlibs:Depends}
Enhances: libignition-math6
Description: Gazebo Math Library - Ruby bindings
 A small, fast, and high performance math library. This library is a
 self-contained set of classes and functions suitable for robot applications.
 .
 Gazebo is a set of simple libraries that provide useful
 functionality to bootstrap robot applications. The included libraries
 encapsulate all the essentials, such as common math data types, console
 logging, 3D mesh management, and asynchronous message passing.
 .
 The package contains the Ruby bindings.

Package: libignition-math6-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
     libignition-math6 (= ${binary:Version}),
     ${misc:Depends}
Multi-Arch: same
Description: Gazebo Math Library - Debugging symbols
 A small, fast, and high performance math library. This library is a
 self-contained set of classes and functions suitable for robot applications.
 .
 Gazebo is a set of simple libraries that provide useful
 functionality to bootstrap robot applications. The included libraries
 encapsulate all the essentials, such as common math data types, console
 logging, 3D mesh management, and asynchronous message passing.

## ignition-math6 6.15.1-3noble.20260113.2027

=== src/python_pybind11/CMakeLists.txt ===
--- 
+++ 
@@ -31,6 +31,7 @@
   src/Matrix3.cc
   src/Matrix4.cc
   src/Matrix6.cc
+  src/MecanumDriveOdometry.cc
   src/MovingWindowFilter.cc
   src/PID.cc
   src/Polynomial3.cc
@@ -124,6 +125,7 @@
     Matrix3_TEST
     Matrix4_TEST
     Matrix6_TEST
+    MecanumDriveOdometry_TEST
     MovingWindowFilter_TEST
     OrientedBox_TEST
     PID_TEST

=== debian/changelog ===
ignition-math6 (6.15.1-3noble.20260113.2027) UNRELEASED; urgency=medium

  * ignition-math6 6.15.1-3 release

 -- MAINTAINER <EMAIL>  Tue, 13 Jan 2026 20:27:32 +0000
